//#include <iomanip.h>
#include <math.h>
#include <stdlib.h>
#include "float.h"
#include "Minimizer.h"
#include <time.h>
#include <stdlib.h>
#include <iomanip.h>


double myrand()
	{
	static int w =0;
	if (w==0) { srand(time(0)); w = 1; }
	double u = double(rand());
	double v =  double(/*stdlib.h*/RAND_MAX); 
	return u/v;
	}

extern "C" {
extern double minimize(int numargs, int nconstr,
	double* xmin, double* xmax, double* x,
        void (*func)(int numargs,int whichFn,double* x,double* ret,void*),
        void (*cFunc)(int numargs,int which,double* x,double* ret,void*));
}

/**
 * Invokes minimize repeatedly and takes the smallest case.
 * @param count times to invoke constrained_min, sample value=80
 * all other parameters are the same as in constrained_min.
 */
double repeatMinimize(int randomize, int count, int numargs, int nconstr,
	double* xmin, double* xmax, double* x,
        void (*func)(int numargs,int whichFn,double* x,double* ret,void*),
        void (*cFunc) (int numargs,int which,double* x,double* ret,void*)
	) {
	double currentMin=DBL_MAX;
	double* y = new double[numargs];
	{for (int i=0;i<numargs;i++) {
		y[i]=x[i];
		x[i]=xmin[i];
	}}
	for (int i=0;i<count;i++) {
		if (randomize)
			for (int j=0;j<numargs;j++) 
				y[j]=xmin[j]+(xmax[j]-xmin[j])*myrand();
		double t;
		t = minimize(numargs,nconstr,xmin,xmax,y,func,cFunc);
		if (t<currentMin) {
			currentMin=t;
			for (int j=0;j<numargs;j++) x[j]=y[j];		
		}
	}
	delete y;
	return currentMin;
	}


Minimizer::Minimizer(int count, int numargs, int nconstr,
		double* xmin, double* xmax) {
	this->count = count;
	this->numargs = numargs;
	this->nconstr= nconstr;
	this->xmin = new double[numargs];
	this->xmax = new double[numargs];
	this->x = new double[numargs];
	this->cFunc = 0;
	this->func = 0;
	for (int i=0;i<numargs;i++) { 
		this->xmin[i]=this->x[i]=xmin[i]; 
		this->xmax[i]=xmax[i];
	}
}

/**
 * @param randomize, set to true to run opimization repeatedly on random input.
 * @param randomize= false: run optimization once starting from given x;
 */
double Minimizer::optimize(int randomize){
	return repeatMinimize(randomize, (randomize?count:1) ,numargs,nconstr,
		xmin,xmax,x,func,cFunc);
}

void Minimizer::coutReport(){
	//cout << endl << endl;
	cout << "Cfsqp minimization results: " << endl;
	cout.precision(18);
	cout << "numargs = " << numargs << endl << flush;
	cout << "constrained min: " << optimize(1) << endl << flush;
	cout << "variables: " << "{";
	for (int i=0;i<numargs;i++) {
		cout << x[i] << (i+1<numargs ? ", ": "}") ;
		if ((i>0)&&(0==(i % 10))) cout << endl;
	}
	cout <<"\nExiting cfsqp numerical report." << endl << flush;	
}

