#include "Minimizer.h"
#include "kepfn.h"
#include <iomanip.h>

/**
  * CHAPTER 5 INEQUALITIES
  */

/**
  * ch2.5A, Bounds on the dihedral angle
  * minimum of dih(qrtet)
  */
void testCH25A1(int,int,double* y,double* ret,void*) {
	*ret = dih(y[0],y[1],y[2],y[3],y[4],y[5]) - 0.805;
}

void runCH25A1() {
	double xmin[6]= {2,2,2,2,2,2};
	double eM = getEdgeMax();
	double xmax[6]= {eM,eM,eM,eM,eM,eM};
	Minimizer M(10,6,0,xmin,xmax);
	M.func = testCH25A1;
	cout << "testCH25A1:" << endl;
	M.coutReport();
	cout << "end-testCH25A1" << endl << endl;
}

void runCH2() {
	runCH25A1();
}
