#include "Minimizer.h"
#include "kepfn.h"
#include <iomanip.h>

/** 
  * TESTS of dihedral angle 
  */

double d1(double* y) {
	return dih(y[0],y[1],y[2],y[3],y[4],y[5]);
}
double d2(double*y) {
	return dih(y[1],y[2],y[0],y[4],y[5],y[3]);
}
double d3(double*y) {
	return dih(y[2],y[0],y[1],y[5],y[3],y[4]);
}

double ad1(double* y) {
	return d1(y)*A(y[0]/2);
}


/**
  * ....
  */
void testDih(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = -dih(y[0],y[1],y[2],y[3],y[4],y[5]) +1.242
		+ 0.757*(y[3]-2.0)
		- 0.156*(y[4]+y[5]-4.0)-0.08*(y[4]+y[5]-4.)*(2.0*eM-y[4]-y[5])//0.156
		+0.327*(y[0]-2.0)+0.388*(y[0]-2.0)*(y[0]-2.0)
		-0.15*(y[1]+y[2]-4.)
		;
}

void testDih2(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = dih(y[0],y[1],y[2],y[3],y[4],y[5]) -1.224
		- 0.72*(y[3]-2.0)
		+ 0.205*(y[4]+y[5]-4.0) +0.17*(y[4]+y[5]-4.)*(2.0*eM-y[4]-y[5])
		+ 0.47*(y[1]+y[2]-4.)
		-0.23*(y[0]-2.0); 
		;
		   
}

void dihqrtet1(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = dih(y[0],y[1],y[2],y[3],y[4],y[5]) - 1.224
			-0.7*(y[3]-2.0)
			+0.285*(y[4]+y[5]-4.0)
			+0.47*(y[1]+y[2]-4.0)
			-0.23*(y[0]-2.0);
}

void dihqrtet2(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = -dih(y[0],y[1],y[2],y[3],y[4],y[5]) +1.242
		+ 0.76*(y[3]-2.0)
		- 0.156*(y[4]+y[5]-4.0)
		+0.54*(y[0]-2.0)
		-0.15*(y[1]+y[2]-4.)
		;
}



void dihqrtet1_22(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = dih(y[0],y[1],y[2],y[3],y[4],y[5]) - 1.224
			-0.7*(y[3]-2.0)
			+0.285*(y[4]+y[5]-4.0)
			+0.42*(y[1]+y[2]-4.0)
			-0.23*(y[0]-2.0);
}


void dihqrtet2_22(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = -dih(y[0],y[1],y[2],y[3],y[4],y[5]) +1.242
		+ 0.76*(y[3]-2.0)
		- 0.156*(y[4]+y[5]-4.0)
		+0.40*(y[0]-2.0)
		-0.21*(y[1]+y[2]-4.)
		;
}

/**
void dihqrtet3(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = -dih(y[0],y[1],y[2],y[3],y[4],y[5]) +1.268
		+ 0.706*(y[3]-2.0)
		- 0.18*(y[4]+y[5]-4.0)
		+0.544*(y[0]-2.0)
		-0.169*(y[1]+y[2]-4.)
		;
}

void dihqrtet4(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = dih(y[0],y[1],y[2],y[3],y[4],y[5]) - 1.2174
			-0.69*(y[3]-2.0)
			+0.27*(y[4]+y[5]-4.0)
			+0.469*(y[1]+y[2]-4.0)
			-0.229*(y[0]-2.0)
			;
}
**/

void solqrtet(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = d1(y)+d2(y)+d3(y)-3.141592653589793
		    - 0.5511
			-0.194*(y[3]+y[4]+y[5]-6.0)
			+0.401*(y[0]+y[1]+y[2]-6.0)
			;
}

void adihqrtet(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = ad1(y)
		    - 0.0565
			-0.0357*(y[3]-2.0)
			+0.0155*(y[4]+y[5]-4.0)
			+0.23*(y[0]-2.0)
			+0.022*(y[1]+y[2]-4.0)
			;
}

void adihqrtet2(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = -ad1(y)
		    + 0.0571
			+0.0356*(y[3]-2.0)
			-0.0068*(y[4]+y[5]-4.0)
			-0.074*(y[0]-2.0)
			-0.0068*(y[1]+y[2]-4.0)
			;
}

void tautqrtet(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = taut(y[0],y[1],y[2],y[3],y[4],y[5])
		     +0.0045
			-0.039*(y[4]+y[5]+y[3]-6.0)
			-0.026*(y[1]+y[2]+y[0]-6.0)
			;
}

void runDihQRtet(void (*func)(int numargs,int whichFn,double* x,double* ret,void*)) {
	double eM = getEdgeMax();
	double xmin[6]= {2,2,2,2,2,2};
	double xmax[6]= {eM,eM,eM,eM,eM,eM};  
	Minimizer M(100,6,0,xmin,xmax);
	M.func = func;
	cout << "testDih:" << endl;
	M.coutReport();
	cout << "end-testDih" << endl << endl;
}

void tauqrtet_22(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = taut(y[0],y[1],y[2],y[3],y[4],y[5])
		     +0.002
			-0.022*(y[4]+y[5]+y[3]-6.0)
			-0.0824*(y[1]+y[2]+y[0]-6.0)
			;
}

void runDihQRtet_22(void (*func)(int numargs,int whichFn,double* x,double* ret,void*)) {
	double eM = getEdgeMax();
	double xmin[6]= {2,2,2,2,2,2};
	double xmax[6]= {2.2,2.2,2.2,eM,eM,eM};
	Minimizer M(100,6,0,xmin,xmax);
	M.func = func;
	cout << "testDih:" << endl;
	M.coutReport();
	cout << "end-testDih" << endl << endl;
}

void qfunc(int,int,double* y,double* ret,void*) {
	//double eM = getEdgeMax();
	*ret = qy(y[0],y[1],y[2]) + 0.01*y[0] + 0.0135*(y[1]+y[2])-0.0776;
}

void constraintSmall(int,int,double* y,double* ret,void*) {
	*ret = -6.25+y[3]+y[4]+y[5];
}

void dihSmall_22(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = d1(y)
			-0.258*(y[0]-2.0)
			+0.312*(y[1]+y[2]-4.0)
			-0.724*(y[3]-2.0)
			+0.273*(y[4]+y[5]-4.0)
			-1.23;
}

void runDihSmall_22() {
	double eM = getEdgeMax();
	double xmin[6]= {2,2,2,2,2,2};
	double xmax[6]= {2.2,2.2,2.2,eM,eM,eM};
	Minimizer M(100,6,1,xmin,xmax);
	M.func = dihSmall_22;
	M.cFunc = constraintSmall;
	cout << "testDih:" << endl;
	M.coutReport();
	cout << "end-testDih" << endl << endl;
}

void runQuoin() {
	double eM = getEdgeMax();
	double xmin[3]={2,2,2};
	double xmax[3]={eM,eM,eM};
	Minimizer M(100,3,0,xmin,xmax);
	M.func = qfunc;
	cout << "testQuoin:" << endl;
	M.coutReport();
	cout << "end-testQuoin" << endl << endl;
}

void runDihG(void (*func)(int numargs,int whichFn,double* x,double* ret,void*),
				 double* xmin0,double* xmax0) {
	double* xmin= xmin0;
	double* xmax= xmax0;
	Minimizer M(500,6,0,xmin,xmax);
	M.func = func;
	cout << "testDih:" << endl;
	M.coutReport();
	cout << "end-testDih" << endl << endl;
}

// These different domains are defined below.
const static int QUARTER3=0;
const static int QUARTER4=1;
const static int eM_OPEN=6;
// opposite edge is sqrt8 or more;
const static int s8_OPEN=9;

const static double s8 = 2.85;

void dih_s8Open1(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = dih(y[0],y[1],y[2],y[3],y[4],y[5]) - 1.92
			+0.404*(y[4]+y[5]-4.0)
			+0.51*(y[1]+y[2]-4.0)
			 -0.335*(y[0]-2.0)
			;
}

void dihQUARTER3(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = -d1(y)
			 +0.79 * (y[0]-2.0)
			-0.22*(y[1]+y[2]-4.0)
			+0.926*(y[3]-eM)
			-0.22*(y[4]+y[5]-4.0)
			+1.663;
}

void dihQUARTER3p(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = d1(y)
			 -0.359 * (y[0]-2.0)
			+0.503*(y[1]+y[2]-4.0)
			-0.9*(y[3]-eM)
			+0.41*(y[4]+y[5]-4.0)
			-1.6564;
}

void dihQUARTER4(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = -d1(y)
			 +0.362 * (y[0]-2.0) 
			-0.225*(y[1]-2.0)
			-0.088*(y[2]-2.0)
			+0.7068*(y[3]-2.0)
			-0.381*(y[4]-eM)
			+0.1495*(y[5]-2.0)
			+1.0709;
}

void dihQUARTER4p(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = +d1(y)
			-0.112 * (y[0]-2.0) 
			+0.679*(y[1]-2.0)
			+0.3485*(y[2]-2.0)
			-0.606*(y[3]-2.0)
			+0.428*(y[4]-eM)
			+0.004*(y[5]-2.0)
			-1.0674;
}

void tauQUARTER3(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = +taut(y[0],y[1],y[2],y[3],y[4],y[5])
			-0.036 * (y[0]-2.0) 
			-0.021*(y[1]+y[2]-4.0)
			-0.062*(y[4]+y[5]-4.0)
			-0.015*(y[3]-eM)
			-0.015;
}

void adihQUARTER3(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = -ad1(y)
			-0.097 * (y[0]-2.0) 
			-0.01*(y[1]+y[2]-4.0)
			-0.01*(y[4]+y[5]-4.0)
			+0.043*(y[3]-eM)
			+0.077;
}

void adihQUARTER4(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = -ad1(y)
			-0.059 * (y[0]-2.0) 
			-0.019 * (y[1]-2.0)
			+0.0039 * (y[2]-2.0)
			+0.0335 * (y[3]-2.0)
			-0.021 * (y[4]-eM)
			+0.0088 * (y[5]-2.0)
			+0.0501
			;
}


void runDih(void (*func)(int numargs,int whichFn,double* x,double* ret,void*),int r) {
	double eM = getEdgeMax();
	double xmin[6] = {2,2,2,2,eM,2};
	double xmax[6] = {eM,eM,eM,eM,s8,eM}; //BUG
	switch(r) {
	case QUARTER3 : xmin[3]=eM; xmax[3]=s8; break;
	case QUARTER4: xmin[4]=eM; xmax[4]=s8; break;
	case eM_OPEN: xmin[3]=xmax[3]=eM; break;
	case s8_OPEN: xmin[3]=xmax[3]=s8; break;
	}
	runDihG(func,xmin,xmax);
	
}




// cf. KEPLER(VI.SecA.4.4)
void dihQUARTER3a(int,int,double*y,double*ret,void*) {
	*ret = d2(y)
			-0.13*y[1]
			+0.64*y[0]
			+0.31*y[2]
			-0.58*y[4]
			+0.413*y[3]
			+0.025*y[5]
			-2.64;
}



void dih_eMOpen1(int,int,double* y,double* ret,void*) {
	double eM = getEdgeMax();
	*ret = dih(y[0],y[1],y[2],y[3],y[4],y[5]) - 1.641
			+0.0*(y[3]-eM)
			+0.396*(y[4]+y[5]-4.0)
			+0.396*(y[1]+y[2]-4.0)
			-0.328*(y[0]-2.0);
}



void runCH() {
	/*
	runDihQRtet(dihqrtet1);
	runDihQRtet(dihqrtet2);
	runQuoin();
	*/
	//runDihQRtet(adihqrtet);
	//runDihQRtet(adihqrtet2);
	//runDihQRtet(tautqrtet);
	//runDihQRtet(solqrtet);
	//runDihQRtet_22(dihqrtet1_22);
	//runDihQRtet_22(dihqrtet2_22);
	//runDih(dih_eMOpen1,eM_OPEN);
	//runDih(dih_s8Open1,s8_OPEN);
	//runDih(dihQUARTER3,QUARTER3);
	//runDih(dihQUARTER3p,QUARTER3);
	//runDih(tauQUARTER3,QUARTER3);
	//runDih(adihQUARTER3,QUARTER3);
	//runDih(adihQUARTER4,QUARTER4);
	runDihQRtet_22(tauqrtet_22);
	//runDihSmall_22();
	//runDih(dihQUARTER4,QUARTER4);
	//runDih(dihQUARTER4p,QUARTER4);


}
