#include "Minimizer.h"
#include "kepfn.h"
//#include <iomanip.h>

//Kepler 2001.
//


/**
 * Minimize sign*( D(y,term) - sum_j cj*y[j] ) over y[i] in [ymj,yMj].
 */
double sign; // pos=1, neg=-1.
double c0,c1,c2,c3,c4,c5; // coefficients of linear adjustments

/**
 */
void GenericDih(int ,int ,double* y,double* ret,void*) {
	*ret = sign*(dih(y[0],y[1],y[2],y[3],y[4],y[5])
			-c0*y[0]
			-c1*y[1]
			-c2*y[2]
			-c3*y[3]
			-c4*y[4]
			-c5*y[5]);
};


/**
 * testing of volan inequality.
 */
/*
void testFunction0(int, int, double* x,double* ret,void*) {
	*ret = volan(x[0],x[1],x[2],x[3],x[4],x[5])-
		volt(x[0],x[1],x[2],x[3],x[4],x[5])+0.00051;
}
*/

/**
 * Minimize sign*( dih(y) - sum_j cj*y[j] ) over y[i] in [ymj,yMj].
 */
double getMinimum(
		int Lrep, // number of reps
		double Lsign, // pos=1, neg=-1.
		double Lc0, double Lc1, double Lc2,
		double Lc3, double Lc4, double Lc5, // coeff of linear terms
		double ym0, double ym1, double ym2,
		double ym3, double ym4, double ym5, // min bounds
		double yM0, double yM1, double yM2,
		double yM3, double yM4, double yM5 // max bounds
		) {
	//1. initialize globals.
	/*
	cout << "1. initialize globals" << endl << flush;
	cout << "received vars ym = " << ym0 << " " << ym1 << " " << ym2 << " " << ym3 << " " << ym4 << " " << ym5 << endl << flush;
	cout << "received vars yM = " << yM0 << " " << yM1 << " " << yM2 << " " << yM3 << " " << yM4 << " " << yM5 << endl << flush;
	cout << "received vars c  = " << Lc0 << " " << Lc1 << " " << Lc2 << " " << Lc3 << " " << Lc4 << " " << Lc5 << endl << flush;
	*/
	sign = Lsign;
	c0 = Lc0; c1 = Lc1; c2 = Lc2; c3 = Lc3; c4 = Lc4; c5 = Lc5;
	//2. initialize locals.
	double ymin[6] = {ym0,ym1,ym2,ym3,ym4,ym5};
	double ymax[6] = {yM0,yM1,yM2,yM3,yM4,yM5};
	//3. optimize
	Minimizer M(Lrep,6,0,ymin,ymax);
	M.func = GenericDih;
	return M.optimize(1);
}

/**
void old_main() {
	getMinimum(10,1.0,
		1.0,1.0,1.0,1.0,1.0,1.0, // coeff.
		2.0,2.0,2.0,2.0,2.0,2.0, // min
		2.51,2.51,2.51,2.51,2.51,2.51 // max
		);
}
**/