#include <math.h>

double getEdgeMax(); 

double getTrunc(); 

double L(double c); // L correction factor.

double M(double y); // M correction factor, y = spine length

double getDtet();

double safesqrt(double t);

double pos(double t);

double delta(double x1,double x2,double x3,double x4,double x5,double x6);

double dih(double y1,double y2,double y3,double y4,double y5,double y6);

double solid(double y1,double y2,double y3,double y4,double y5, double y6); 

double eta(double y1,double y2,double y3); 

double uT(double x1, double x2, double x3);

double rad(double y1,double y2,double y3,double y4,double y5,double y6); 

double quoin(double a,double b,double c); 

double qy(double y1, double y2, double y3); 

double qy(double y1, double y2, double y3, double trunc); 

double beta(double psi,double theta);

double arc(double y1,double y2,double y3);

double phi(double h, double t); 

double phi0(); 

double A(double h, double t); 

double A(double h); 

double volt(double y1,double y2,double y3,double y4,double y5,double y6); 

double taut(double y1,double y2,double y3,double y4,double y5,double y6); 

double volR(double a,double b,double c); 

double volan(double y1,double y2,double y3,double y4,double y5,double y6); 

double volq(double y1,double y2,double y3,double y4,double y5,double y6,double trunc);

// full quad cluster:
// we use mod three numbering:
//  	indices on back simplex are standard order mod 3.
//
//y[0],y[1],y[2],y[3],y[4],y[5] = 1st simplex. y[3]=diag.
//y[6],y[1],y[2],y[3],y[7],y[8] = 2nd simplex.
//
//opposite pairs: (y[4],y[8]),(y[5],y[7]),(y[0],y[6]),
//			(y[1],y[2])
//diagonals: y[3], other is between (0,6), computed by crossdiag(y);
// corners are 0,1,2,6.
//
double crossdiag(double y[9]);


