/* based in part on Sam Ferguson's macros.h */

#ifndef notPortableH
#define notPortableH

#define DA_SYSTEM 4// 5 turns of rounding.


#if DA_SYSTEM == 1 /* PPC, PowerMac */

#define ROUND_UP        fesetround(FE_UPWARD)
#define ROUND_DOWN      fesetround(FE_DOWNWARD)
#define ROUND_NEAR      fesetround(FE_TONEAREST)
#define ROUND_ZERO      fesetround(FE_TOWARDZERO)
#define ISNAN( x )      isnan( x )
#define INTERVAL_ON	1 

#elif DA_SYSTEM == 2    /* Sparc */

#include <float.h>
#include <stdlib.h>
#include <ieeefp.h>

#define ROUND_UP        ieee_flags("set","direction","positive",0);
#define ROUND_DOWN      ieee_flags("set","direction","negative",0);
#define ROUND_NEAR      ieee_flags("set","direction","nearest",0);
#define ROUND_ZERO      ieee_flags("set","direction","tozero",0);
#define ISNAN( x )      isnan( x )
#define INTERVAL_ON	1

#elif DA_SYSTEM == 3    /* SGI, Solaris */

#include <float.h>
#include <stdlib.h>
#include <ieeefp.h>

#define ROUND_UP        fpsetround( FP_RP )
#define ROUND_DOWN      fpsetround( FP_RM )
#define ROUND_NEAR      fpsetround( FP_RN )
#define ROUND_ZERO      fpsetround( FP_RZ )
#define ISNAN( x )      isnand( x )
#define INTERVAL_ON	1

#elif DA_SYSTEM == 4    /* PC- Pentium  */

#include <float.h>
#include <stdlib.h>

// copied from float.h:

//#define MCW_EM              0x003f  /* interrupt Exception Masks*/

//#define     EM_DENORMAL     0x0002  /*   denormal               */

//#define MCW_RC          0x0c00  /* Rounding Control     */
//#define     RC_CHOP     0x0c00  /*   chop               */
//#define     RC_UP       0x0800  /*   up                 */
//#define     RC_DOWN     0x0400  /*   down               */
//#define     RC_NEAR     0x0000  /*   near               */

#define ROUND_UP	_controlfp( RC_UP, MCW_RC )
#define ROUND_DOWN	_controlfp( RC_DOWN, MCW_RC )
#define ROUND_ZERO	_controlfp( RC_CHOP, MCW_RC )
#define ROUND_NEAR	_controlfp( RC_NEAR, MCW_RC )

/** the Borland compiled code stops with an interrupt in the test
 * suite, unless this line is included to silence exceptions
 */
#define QUIET_EXCEPTION _control87( MCW_EM, MCW_EM ) 

#define INTERVAL_ON	1

#elif DA_SYSTEM == 5    /* rounding turned off */

#define ROUND_UP        
#define ROUND_DOWN      
#define ROUND_NEAR      
#define ROUND_ZERO      
#define ISNAN( x )      0
#define INTERVAL_ON	0
#define QUIET_EXCEPTION

#endif


#endif
